.286




; Procedure SORT
; Input:  ES:DI -> array of words to sort
;		 cx = length
; Output:
; Modifies:
SORT	PROC

	ASSUME CS:CODE, DS:DATA, SS:STACK_SEG
	pusha
	; ax bruges som holder for tal
	; bx bruges som nuvrende element
	; cx bruges som tller for antallet af elementer der er tilbage
	; dx bruges som flag for ombytninger
	dec		cx
REPEAT1:
	mov		bx,0
	mov		dx,FALSK
REPEAT2:
	shl		bx, 1
	mov		Ax, es:[di+bx]
	cmp		Ax, es:[di+bx+2]
	jna		INCSI
	xchg	Ax, es:[di+bx+2]
	mov		es:[di+bx],Ax
	mov	   dx, SAND
INCSI:
	shr		bx, 1
	inc		bx
	cmp		bx,cx
	jne		REPEAT2
	dec		cx
	cmp		cx,0			 ;rettet 1 til 0
	je		EXIT
	cmp		dx, FALSK
	jne		REPEAT1
EXIT:
	popa
	ret
SORT	ENDP


; The InputString method will take a pointer to a buffer in ES:DI and read a string into the buffer.
; The buffer length is supplied in CX
; The buffer will be zero'ed out before reading occurs
; Input: ES:DI -> buffer
;        CX - length of buffer
; Uses:  AX, BX, CX, DX
InputString PROC NEAR	
	DATA SEGMENT
		bufferlength equ 256
		localbuffer	db bufferlength dup(0)	; allocate a local buffer
		inputbuffersz dw 0;
	DATA ENDS
	
	pusha
	push	ds						; protect DS
	mov		ax, DATA				; load DS with DATA segment
	mov		ds, ax
	
	
	mov		inputbuffersz, cx		; save CX for later use
	
	; Reset destination memory block
	cld
	xor		ax, ax					; reset ax
	push	di						; save DI pointer
	rep	stosb						; reset memory block
	pop		di						; restore DI
	
	mov		si, offset localbuffer	; load DX with DI
	mov		byte ptr [si], bufferlength-1		; prepare buffer
	mov		dx, si
	; now DS:DX points to local buffer with string
	DOS_CALL(DOS_READLN)
	; by now the local buffer is filled with the string read
	; at [0] in buffer, buffer-length 
	; at [1] in buffer, read count (including CR)
	; at [2] first read byte
	mov		cl, [localbuffer+1]
	xor		ch, ch
	cmp		cx, inputbuffersz		; restore saved length
	jbe		IS_CopyBuffer
	mov		cx, inputbuffersz		; set as max length
IS_CopyBuffer:
	mov		si, offset localbuffer+2
	rep		movsb
	mov		byte ptr es:[di], 0	; erase the last character (carriage return)
	
	
	; done reading input
	pop		ds
	popa
	ret
InputString ENDP


; Procedure to output a zero-terminated string to the screen.
; Input:  ES:DI - pointer to string
; Output: 
OutputString PROC NEAR
	pusha

	mov		dx, di
	
	; replace 0 at end of string with '$'
	cld
	mov		al, 0
	mov		cx, 255
	repne	scasb
	dec		di
	mov		BYTE PTR es:[di], '$'
	
	; print string using dos services
	push	ds
	mov		ax, es
	mov		ds, ax
	DOS_CALL(DOS_WRITELN)
	pop		ds
	; restore 0 at end-of-string
	mov		BYTE PTR es:[di], 0
	
	; return code
	popa
	ret
OutputString ENDP



; This procedure will fill a string with a right-justified word-value in base-10
; Input: ES:DI - pointer to string
;        AX - number to convert
;        CX - field size
; Output ES:DI is modified
WordToString PROC NEAR
	DATA SEGMENT
		output_length dw 0 
		output_dest dd ?
	DATA ENDS
	
	pusha
	dec		cx
	; reset memory loc.
	push	ax
	push	cx
	cld
	mov		al, ' '
	rep stosb
;	dec		di
	pop		cx
	pop		ax
	
	; set backwards direction
	std
	; while ax!=0 do ax := ax div 10, remainder in dx
	mov		bx, 10 
WTS_NEXTCHAR:
;	cwd
	xor		dx, dx
	div		bx
	add		dl, '0'
	xchg	ax, dx
	stosb
	xchg	ax, dx
	cmp		ax, 0
	je		WTS_DONE
	loop	WTS_NEXTCHAR
WTS_DONE:
	
	cld	
	popa
	ret
WordToString ENDP


; Procedure DecodeNumber
; Input: es:di -> string with digits
;        cx = length of string
; Output: ax = value of number
DECODENUMBER PROC
	push	bx
	push	cx
	push	dx
	push	di
	
	xor	dx, dx
	xor	bx, bx
	xor	ax, ax
SKIP_SPACE:
	jcxz	DN_EXIT
	mov	bl, es:[di]
	inc	di
	dec	cx
	cmp	bl, ' '
	je	SKIP_SPACE
	
	
	sub	bl, '0'
	imul	ax,10
	add	ax, bx
DECODE_DIGIT:
	mov	bl, es:[di]
	inc	di
	sub	bl,'0'
	imul	ax,10
	add	ax, bx
	loop DECODE_DIGIT

DN_EXIT:
	pop	di
	pop	dx
	pop	cx
	pop	bx
	ret
DECODENUMBER ENDP



; Procedure to calculate the sum of an array of words (result is 32-bits, but upper 16 can be ignored)
; Input: ES:DI -> array
;        CX -> elements in array
; Output: DX:AX = sum of array elements
; Modifies: AX, DX
SumWordArray PROC NEAR
	push	di
	push	cx
	
	; reset DX:AX
	xor		ax, ax
	xor		dx, dx
	; for each word in array do:
SWA_NEXTWORD:
	; a 32-bit add of DX:AX with word on [es:di]
	add		ax, es:[di]
	adc		dx, 0
	; move pointer to next word
	inc		di
	inc		di
	; loop until no more elements in array
	loop	SWA_NEXTWORD
	
	; restore cx and di
	pop		cx
	pop		di
	ret
SumWordArray ENDP

