.286



INCLUDE ERKLRING.ASM

CODE SEGMENT
	ASSUME DS:DATA,CS:CODE,ES:DATA,SS:STACK_SEG
	
; Procedure Fail
; Terminates program with errormessage
; Input: al = DOS error code
; Return: never, terminates prog.
FAIL	PROC
	xor	ah, ah
	cmp	al, 8
	jbe	print
	mov	al, 7
print:
	xor	bx, bx
	mov	bl, al
	shl	bx, 1
	mov	dx, FEJLPEGER[bx]
	mov	ah, DOS_WRITELN
	int	21h
	mov	ah, 4Ch
	INT	21h
FAIL	ENDP


INCLUDE GENERAL.INC



DATA SEGMENT
	NOERROR   DB 'Ingen fejl$'
	INVALIDFN DB 'Funktionsnummer ugyldigt$'
	NOTFOUND  DB 'Fil ej fundet$'
	NOPATH    DB 'Sti ej fundet$'
	NOHANDLE  DB 'Filhndtag ikke tilgngeligt$'
	NOACCESS  DB 'Ej filadgang$'
	NOTOPEN   DB 'Fil ej ben$'
	FYLD      DB 'Ukendt fejl$'
	FEJLPEGER DW NOERROR, INVALIDFN, NOTFOUND,NOPATH, NOHANDLE, NOACCESS, NOTOPEN, FYLD, SUMFEJL
	INDRYKKER DB 'Aaben filnavn -> ',0
	UDRYKKER  DB 'Skriv til filnavn ->',0
	SUMBESKED DB 'Sum = ',0
	TIDBESKED DB 'Tid = ',0
	BUFLEN    DB  128
	AKTLEN    DB    0
	BUFFER    DB  128 DUP(0)
	HANDLE    DW    0
	TABEL     DW 1200 DUP(0)
	ANTAL     DW    0
	OMBYTTET  DB FALSK
	CRFLAG    DB    0
	CREATE    DB    0
	ANTLINJER DB    0
	CRLF      DB    CR,LF,0
	SEK       DB 0
	S100      DB 0
	SUMFOR    DD 0
	SUMEFT    DD 0
	FILNAVN   db 13 dup (0)
	velkommen db ">> ",??FILENAME," <<",10,13,"--------------",10,13,"Compiled at: ",??DATE," ",??TIME,10,10,13,0
	sumstreng db "Summen af alle elementer er: ",0
	string db 256 dup(0)			; create an empty string
	elementnr dw 0
	antaltilbage dw ?
	sumfejl   db 'Sumberegning fejlede',10,13,0
	sumok 	  db 'Sumberegning ok',10,13,0
	arbejder  db 'Filen behandles...',10,13,0
		
DATA      ENDS


; PrintTabel udskriver den tabel, der er inkluderet i tabel. Lngden (antal elementer) angives i antal
; ES modificeret
PrintTabel PROC NEAR
	; CX tller antal elementer, sttes lig antal
	; elementnr tller antal elementer p denne linje
	ANTAL_PER_LINJE equ 12
	FELT_BREDDE equ 6
	pusha

	; Opret ny fil
	mov	cx, 0
	mov	dx, offset FILNAVN
	DOS_CALL (DOS_CREATEFILE)
	mov	HANDLE, ax
	; Now file is open and handle is in HANDLE
	

	; klargr registre - der arbejdes i string-variablen
	mov		cx, antal
	
	; ds:si peger p tabel
	cld
	mov		si, offset tabel
	
	
PT_NAESTE_LINJE:
	mov		di, offset string
	mov		elementnr, 0
PT_NAESTE_ELEM:
	jcxz	PT_SKRIV_LINJE
	lodsw	; ax=ds:si, si+=2
	push	cx
	mov		cx, FELT_BREDDE
	call	WordToString
	pop		cx
	add		di, FELT_BREDDE
	inc		elementnr
	dec		cx
	cmp		elementnr, ANTAL_PER_LINJE
	jae		PT_SKRIV_LINJE
	jmp		PT_NAESTE_ELEM
PT_SKRIV_LINJE:
	mov		word ptr es:[di], 0D0Ah
	inc		di
	inc		di
	mov		byte ptr es:[di], 0
	
;	mov		di, offset string
;	call	OutputString

	pusha
	mov		cx, di
	sub		cx, offset string
	mov		dx, offset string
	mov		bx, handle
	DOS_CALL(DOS_WRITEFILE)
	popa
	
	cmp		cx, 0
	jne		PT_NAESTE_LINJE
	
	; Close file again
	mov	bx, HANDLE
	DOS_CALL (DOS_CLOSEFILE)
	
	popa
	ret
PrintTabel ENDP




; Procedure ReadFile
; Assumes DS points to data-segment
; tries to open file
; if it fails, it calls FAIL
READFILE PROC
	pusha
	
	
	; Open the file by calling DOS
	mov	al, 0
	mov	dx, offset FILNAVN
	DOS_CALL (DOS_OPENFILE)
	mov	HANDLE, ax
	; Now file is open and handle is in HANDLE

RF_LINE:
	; Read one line from file (assumed line length is always 74 bytes)
	mov	bx, HANDLE
	mov	cx, LINELENGTH
	mov	dx, offset BUFFER
	DOS_CALL (DOS_READFILE) 
	cmp	ax, 0
	je	RF_DONE
	
	; Start decoding the line element by element
	mov	cx, 12
	mov	di, offset BUFFER
RF_ELEM:
	; decode current element
	push	cx
	mov		cx, 6
	call	decodeNumber
	mov		bx, ANTAL
	shl		bx, 1	
	mov		TABEL[bx], ax
	inc		ANTAL
	add		di, 6			; move to next element
	pop		cx
	loop	RF_ELEM
	jmp	RF_LINE
	
	
RF_DONE:
	; Close file again
	mov	bx, HANDLE
	DOS_CALL (DOS_CLOSEFILE)
	
	; End procedure	
	popa
	ret
	
READFILE ENDP




; Procedure DecodeLine
; assumes buffer filled with 102 characters
; 


TELLER	EQU 7


			ASSUME CS:CODE,DS:DATA,ES:DATA,SS:STACK_SEG
START:	
	mov		ax,DATA
	mov		ds,ax
	mov		es,ax
	mov		ax,STACK_SEG
	mov		SS,ax
	mov		SP,OFFSET STACK_TOP
	
	
	mov		di, offset velkommen
	call	OutputString

	mov		di, offset indrykker
	call	OutputString

	mov		di, offset filnavn
	mov		cx, 13
	call	InputString

	mov		di, offset crlf
	call	OutputString

	mov		di, offset arbejder
	call	OutputString


;	DOS_CALL(DOS_GETTIME)
	
	
		
	call	readfile
	
	mov		di, offset tabel
	mov		cx, antal
	call	SumWordArray
	mov		word ptr sumfor, ax
	mov		word ptr sumfor+2, dx
	
	mov	ax, ds
	mov	es, ax
	mov	di, offset TABEL
	mov	cx, ANTAL
	call	sort
	
	mov		di, offset tabel
	mov		cx, antal
	call	SumWordArray
	mov		word ptr sumeft, ax
	mov		word ptr sumeft+2, dx

	cmp		ax, word ptr sumfor
	jne		_sumfejl
	cmp		dx, word ptr sumfor+2
	je		_sumok

_SUMFEJL: 
	mov		di, offset sumfejl
	jmp		videre
	
_SUMOK:		
	mov		di, offset sumok
	
VIDERE:		
	call	OutputString

	mov		di, offset udrykker
	call	OutputString

	mov		di, offset filnavn
	mov		cx, 13
	call	InputString

	call	PrintTabel
	
	DosTerminate 0
CODE	ENDS
END	START

