; Lotteri-program - del 2
; Denne del vil srge for indlsning af filnavn




.286

INCLUDE MACRO.MAC


STACK_SEG SEGMENT
	 thestack dw 400h dup(0)
	 STACK_TOP LABEL word
STACK_SEG ENDS




CODE SEGMENT
	ASSUME DS:DATA, ES:DATA, CS:CODE, SS:STACK_SEG


Fail PROC NEAR
	DosTerminate(1)
Fail ENDP




; The InputString method will take a pointer to a buffer in ES:DI and read a string into the buffer.
; The buffer length is supplied in CX
; The buffer will be zero'ed out before reading occurs
; Input: ES:DI -> buffer
;        CX - length of buffer
; Uses:  AX, BX, CX, DX
InputString PROC NEAR	
	DATA SEGMENT
		bufferlength equ 256
		localbuffer	db bufferlength dup(0)	; allocate a local buffer
		inputbuffersz dw 0;
	DATA ENDS
	
	pusha
	push	ds						; protect DS
	mov		ax, DATA				; load DS with DATA segment
	mov		ds, ax
	
	
	mov		inputbuffersz, cx		; save CX for later use
	
	; Reset destination memory block
	cld
	xor		ax, ax					; reset ax
	push	di						; save DI pointer
	rep	stosb						; reset memory block
	pop		di						; restore DI
	
	mov		si, offset localbuffer	; load DX with DI
	mov		byte ptr [si], bufferlength-1		; prepare buffer
	mov		dx, si
	; now DS:DX points to local buffer with string
	DOS_CALL(DOS_READLN)
	; by now the local buffer is filled with the string read
	; at [0] in buffer, buffer-length 
	; at [1] in buffer, read count (including CR)
	; at [2] first read byte
	mov		cl, [localbuffer+1]
	xor		ch, ch
	cmp		cx, inputbuffersz		; restore saved length
	jbe		IS_CopyBuffer
	mov		cx, inputbuffersz		; set as max length
IS_CopyBuffer:
	mov		si, offset localbuffer+2
	rep		movsb
	mov		byte ptr es:[di], 0	; erase the last character (carriage return)
	
	
	; done reading input
	pop		ds
	popa
	ret
InputString ENDP


; Procedure to output a zero-terminated string to the screen.
; Input:  ES:DI - pointer to string
; Output: 
OutputString PROC NEAR
	pusha

	mov		dx, di
	
	; replace 0 at end of string with '$'
	cld
	mov		al, 0
	mov		cx, 255
	repne	scasb
	dec		di
	mov		BYTE PTR es:[di], '$'
	
	; print string using dos services
	push	ds
	mov		ax, es
	mov		ds, ax
	DOS_CALL(DOS_WRITELN)
	pop		ds
	; restore 0 at end-of-string
	mov		BYTE PTR es:[di], 0
	
	; return code
	popa
	ret
OutputString ENDP



; This procedure will fill a string with a right-justified word-value in base-10
; Input: ES:DI - pointer to string
;        AX - number to convert
;        CX - field size
; Output ES:DI is modified
WordToString PROC NEAR
	DATA SEGMENT
		output_length dw 0 
		output_dest dd ?
	DATA ENDS
	
	pusha
	dec		cx
	; reset memory loc.
	push	ax
	push	cx
	cld
	mov		al, ' '
	rep stosb
;	dec		di
	pop		cx
	pop		ax
	
	; set backwards direction
	std
	; while ax!=0 do ax := ax div 10, remainder in dx
	mov		bx, 10 
WTS_NEXTCHAR:
;	cwd
	xor		dx, dx
	div		bx
	add		dl, '0'
	xchg	ax, dx
	stosb
	xchg	ax, dx
	cmp		ax, 0
	je		WTS_DONE
	loop	WTS_NEXTCHAR
WTS_DONE:
	
	cld	
	popa
	ret
WordToString ENDP



; Procedure to calculate the sum of an array of words (result is 32-bits, but upper 16 can be ignored)
; Input: ES:DI -> array
;        CX -> elements in array
; Output: DX:AX = sum of array elements
; Modifies: AX, DX
SumWordArray PROC NEAR
	push	di
	push	cx
	
	; reset DX:AX
	xor		ax, ax
	xor		dx, dx
	; for each word in array do:
SWA_NEXTWORD:
	; a 32-bit add of DX:AX with word on [es:di]
	add		ax, es:[di]
	adc		dx, 0
	; move pointer to next word
	inc		di
	inc		di
	; loop until no more elements in array
	loop	SWA_NEXTWORD
	
	; restore cx and di
	pop		cx
	pop		di
	ret
SumWordArray ENDP





DATA SEGMENT
	prompt db "Please enter a string ->",0
	newline db 10,13,0
	outp db "You entered: ",0
	testmessage db "This is a test message",10,13,0
	aword dw 12345
	
	velkommen db ">> ",??FILENAME," <<",10,13,"--------------",10,13,"Compiled at: ",??DATE," ",??TIME,10,10,13,0
	sumstreng db "Summen af alle elementer er: ",0
	string db 256 dup(0)			; create an empty string
	tabel dw 10,20,30,40,50,60,70,80,90,100, 110, 120, 1,2,3,4,5,6,7,8,9,10,11,12,99,98,97,96,95,94,93,92,91,90,89,88,987,123
	antal dw 38
	elementnr dw 0
	antaltilbage dw ?
DATA ENDS


; PrintTabel udskriver den tabel, der er inkluderet i tabel. Lngden (antal elementer) angives i antal
; ES modificeret
PrintTabel PROC NEAR
	; CX tller antal elementer, sttes lig antal
	; elementnr tller antal elementer p denne linje
	ANTAL_PER_LINJE equ 12
	FELT_BREDDE equ 6
	pusha
	; klargr registre - der arbejdes i string-variablen
	mov		ax, ds
	mov		es, ax
	mov		cx, antal
	
	; ds:si peger p tabel
	cld
	mov		si, offset tabel
	
	
PT_NAESTE_LINJE:
	mov		di, offset string
	mov		elementnr, 0
PT_NAESTE_ELEM:
	jcxz	PT_SKRIV_LINJE
	lodsw	; ax=ds:si, si+=2
	push	cx
	mov		cx, FELT_BREDDE
	call	WordToString
	pop		cx
	add		di, FELT_BREDDE
	inc		elementnr
	dec		cx
	cmp		elementnr, ANTAL_PER_LINJE
	jae		PT_SKRIV_LINJE
	jmp		PT_NAESTE_ELEM
PT_SKRIV_LINJE:
	mov		word ptr es:[di], 0D0Ah
	inc		di
	inc		di
	mov		byte ptr es:[di], 0
	mov		di, offset string
	call	OutputString
	cmp		cx, 0
	jne		PT_NAESTE_LINJE
	
	
	popa
	ret
PrintTabel ENDP





START:
	mov		ax, STACK_SEG
	mov		ss, ax
	mov		sp, offset STACK_TOP
	mov		ax, DATA
	mov		ds, ax
	mov		es, ax
	
	mov		di, offset velkommen
	call	OutputString

COMMENT "
	mov		di, offset prompt
	call	OutputString
	mov		di, offset string
	mov		cx, 255
	call	InputString
	mov		di, offset newline
	call	OutputString

	mov		di, offset outp
	call	OutputString
	mov		di, offset string
	call	OutputString
	mov		di, offset newline
	call	OutputString

	mov		ax, aword
	mov		cx, 10
	mov		di, offset string
	call	WordToString
	call	OutputString
	mov		di, offset newline
	call	OutputString
"
	call	PrintTabel
	
	mov		di, offset tabel
	mov		cx, antal
	call	SumWordArray
	mov		di, offset string
	mov		cx, 10
	call	WordToString
	add		di, 10
	mov		byte ptr es:[di], 0
	mov		di, offset SumStreng
	call	OutputString
	mov		di, offset string
	call	OutputString
	
	
	DosTerminate(0)
CODE ENDS


END START
