#ifndef TYPES_H
#define TYPES_H

/*-------------------------------------------------------------------
 * Definition af standard-typer */
#define MIN(a,b) (a>b?b:a)
#define MAX(a,b) (a<b?b:a)
#define TRUE 1
#define FALSE 0
typedef unsigned short int byte;
typedef byte bool;
typedef unsigned int uint;
typedef unsigned long ulong;


/*-------------------------------------------------------------------
 * Definition af simulationstyper */
#define MAX_USER_NAME 10
struct SimParam {
	double L;		/* Induktion */
	double R;		/* Resistans */
	double C;		/* Kapacitet */
	double U0;		/* Spndingsspring til tiden 0 */
	double T;		/* Maks tid, simulationsperiode */
	uint   points; /* Antal simulations-punkter */
	double damp;	/* Dmpningsparameter (beregnes) */
	double frq;		/* basisfrekvens  (beregnes) */
	char user[MAX_USER_NAME+1]; /* brugernavn */
};


struct SimEntry {
	float mSec;
	float volt;
	float mAmp;
};

#endif
